'*** This script sets the local computer's date and time based on the values
'*** retrieved from the Oracle database server.
'***
'*** M.Kizer (09/21/2006) - Created.

Option Explicit

'* Define Constants / Variables
Const DateTimeSQL = "SELECT TO_CHAR(SYSDATE,'MM-DD-YYYY HH24:MI:SS') AS DateTime FROM DUAL"				'SQL command to retrieve date and time from server
Dim connectionString: connectionString = "DRIVER={Microsoft ODBC for Oracle};SERVER=servername;User Id=userID;Password=password;"
Dim sDate
Dim sTime
Dim sCmd
Dim iRC1
Dim iRC2

'* Create the connection
Dim connection: Set connection = CreateObject("ADODB.Connection")
Dim rows: Set rows = CreateObject("ADODB.Recordset")

'* Create objects
Dim WshShell
Set WshShell = CreateObject("WScript.Shell")

Dim fso
Set fso = CreateObject("Scripting.FileSystemObject")

'* Create log file
Dim LogFile
Set LogFile = fso.CreateTextFile("DBSetDateTime.log", true)
LogFile.WriteLine("================================================================================")
LogFile.WriteLine("|   DBSetDateTime.vbs Log                                                      |")
LogFile.WriteLine("================================================================================")
LogFile.WriteBlankLines 1
LogFile.WriteLine("Current computer date and time: " & Now)
LogFile.WriteBlankLines 1

'* Open connection
connection.Open connectionString

'* Execute SQL
Set rows = connection.Execute(DateTimeSQL)

While Not rows.EOF
    '* Populate variables with results from the query
    sDate = Left(rows.Fields("DateTime").Value, 10)
    sTime = Right(rows.Fields("DateTime").Value, 8)
	LogFile.WriteLine("Retrieved database server date: " & sDate & " and time: " & sTime)
	LogFile.WriteBlankLines 1
    
    rows.MoveNext
Wend

'* Set the local computer's date and time
sCmd = "cmd.exe /c time " + sTime
iRC1 = WshShell.Run(sCmd, 0, TRUE)
if iRC1 <> 0 then
	LogFile.WriteLine("*** Error returned from time command: " & iRC1)
End if

sCmd = "cmd.exe /c date " + sDate
iRC2 = WshShell.Run(sCmd, 0, TRUE)
if iRC2 <> 0 then
	LogFile.WriteLine("*** Error returned from date command: " & iRC2)
End if

If iRC1 = 0 And iRC2 = 0 Then
	LogFile.WriteLine("Computer date and time updated successfully.")
Else
	LogFile.WriteLine("Computer date and time update failed!")
End If

LogFile.WriteBlankLines 1
LogFile.WriteLine("================================================================================")

'* Close log file
LogFile.Close

'* Close connection and clean up objects
connection.Close
Set rows = Nothing
Set connection = Nothing
Set WshShell = Nothing
Set fso = Nothing
Set LogFile = Nothing
